package com.diagbot.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.diagbot.dto.BehospitalInfoDTO;
import com.diagbot.dto.MsgDTO;
import com.diagbot.dto.NumDTO;
import com.diagbot.entity.BehospitalInfo;
import com.diagbot.vo.AnalyzeVO;
import com.diagbot.vo.BehospitalPageVO;
import com.diagbot.vo.FilterByDeptVO;
import com.diagbot.vo.FilterVO;
import com.diagbot.vo.HPFilterByDeptVO;
import com.diagbot.vo.HomePageFilterVO;

import java.util.List;

/**
 * <p>
 * 住院病历信息 服务类
 * </p>
 *
 * @author zhoutg
 * @since 2020-04-13
 */
public interface BehospitalInfoService extends IService<BehospitalInfo> {

    public IPage<BehospitalInfoDTO> getPage(BehospitalPageVO behospitalPageVO);

    public List<MsgDTO> getMsg(AnalyzeVO analyzeVO);

    /**
     * 缺陷排行列表统计
     *
     * @param filterVO
     * @return
     */
    public List<NumDTO> resultStatistics(FilterVO filterVO);

    /**
     * 各科室缺陷占比
     *
     * @param filterVO
     * @return
     */
    public List<NumDTO> resultStatisticsByDept(FilterVO filterVO);

    /**
     * 缺陷排行列表统计-百分比未计算
     *
     * @param filterVO
     * @return
     */
    public List<NumDTO> resultStatistics2(FilterVO filterVO);

    /**
     * 各科室缺陷占比-百分比未计算
     *
     * @param filterVO
     * @return
     */
    public List<NumDTO> resultStatisticsByDept2(FilterVO filterVO);

    /**
     * 缺陷总数
     *
     * @param filterVO
     * @return
     */
    public int getTotleResultNum(FilterVO filterVO);


    public List<BehospitalInfo> getNoGrade();

    IPage<BehospitalInfoDTO> getPageByDept(BehospitalPageVO behospitalPageVO);

    IPage<BehospitalInfoDTO> getPageByPerson(BehospitalPageVO behospitalPageVO);

    /**
     * 病案首页相关病历数统计
     *
     * @param homePageFilterVO
     * @return
     */
    public int homePageCount(HomePageFilterVO homePageFilterVO);

    /**
     * 手术病历数统计
     *
     * @param filterVO
     * @return
     */
    public int homePageCountForOperation(FilterVO filterVO);

    /**
     * 按科室统计病案首页病历数
     *
     * @param hpFilterByDeptVO
     * @return
     */
    public List<NumDTO> homePageCountByDept(HPFilterByDeptVO hpFilterByDeptVO);

    /**
     * 按科室统计病案首页手术病历数
     *
     * @param filterByDeptVO
     * @return
     */
    public List<NumDTO> homePageCountForOperationByDept(FilterByDeptVO filterByDeptVO);
}