package com.diagbot.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.diagbot.dto.BehospitalInfoDTO;
import com.diagbot.dto.MsgDTO;
import com.diagbot.dto.NumDTO;
import com.diagbot.entity.BehospitalInfo;
import com.diagbot.mapper.BehospitalInfoMapper;
import com.diagbot.service.BehospitalInfoService;
import com.diagbot.vo.AnalyzeVO;
import com.diagbot.vo.BehospitalPageVO;
import com.diagbot.vo.FilterByDeptVO;
import com.diagbot.vo.FilterVO;
import com.diagbot.vo.HPFilterByDeptVO;
import com.diagbot.vo.HomePageFilterVO;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 住院病历信息 服务实现类
 * </p>
 *
 * @author zhoutg
 * @since 2020-04-13
 */
@Service
public class BehospitalInfoServiceImpl extends ServiceImpl<BehospitalInfoMapper, BehospitalInfo> implements BehospitalInfoService {

    @Override
    public IPage<BehospitalInfoDTO> getPage(BehospitalPageVO behospitalPageVO) {
        return baseMapper.getPage(behospitalPageVO);
    }

    @Override
    public List<MsgDTO> getMsg(AnalyzeVO analyzeVO) {
        return baseMapper.getMsg(analyzeVO);
    }

    /**
     * 缺陷排行列表统计
     *
     * @param filterVO
     * @return
     */
    @Override
    public List<NumDTO> resultStatistics(FilterVO filterVO) {
        return baseMapper.resultStatistics(filterVO);
    }

    /**
     * 各科室缺陷占比
     *
     * @param filterVO
     * @return
     */
    @Override
    public List<NumDTO> resultStatisticsByDept(FilterVO filterVO) {
        return baseMapper.resultStatisticsByDept(filterVO);
    }

    /**
     * 缺陷排行列表统计-百分比未计算
     *
     * @param filterVO
     * @return
     */
    @Override
    public List<NumDTO> resultStatistics2(FilterVO filterVO) {
        return baseMapper.resultStatistics2(filterVO);
    }

    /**
     * 各科室缺陷占比-百分比未计算
     *
     * @param filterVO
     * @return
     */
    @Override
    public List<NumDTO> resultStatisticsByDept2(FilterVO filterVO) {
        return baseMapper.resultStatisticsByDept2(filterVO);
    }

    /**
     * 缺陷总数
     *
     * @param filterVO
     * @return
     */
    @Override
    public int getTotleResultNum(FilterVO filterVO) {
        return baseMapper.getTotleResultNum(filterVO);
    }

    @Override
    public List<BehospitalInfo> getNoGrade() {
        return baseMapper.getNoGrade();
    }

    @Override
    public IPage<BehospitalInfoDTO> getPageByDept(BehospitalPageVO behospitalPageVO) {
        return baseMapper.getPageByDept(behospitalPageVO);
    }

    @Override
    public IPage<BehospitalInfoDTO> getPageByPerson(BehospitalPageVO behospitalPageVO) {
        return baseMapper.getPageByPerson(behospitalPageVO);
    }

    /**
     * 病案首页相关病历数统计
     *
     * @param homePageFilterVO
     * @return
     */
    @Override
    public int homePageCount(HomePageFilterVO homePageFilterVO) {
        return baseMapper.homePageCount(homePageFilterVO);
    }

    /**
     * 手术病历数统计
     *
     * @param filterVO
     * @return
     */
    @Override
    public int homePageCountForOperation(FilterVO filterVO) {
        return baseMapper.homePageCountForOperation(filterVO);
    }

    /**
     * 按科室统计病案首页病历数
     *
     * @param hpFilterByDeptVO
     * @return
     */
    @Override
    public List<NumDTO> homePageCountByDept(HPFilterByDeptVO hpFilterByDeptVO) {
        return baseMapper.homePageCountByDept(hpFilterByDeptVO);
    }

    /**
     * 按科室统计病案首页手术病历数
     *
     * @param filterByDeptVO
     * @return
     */
    @Override
    public List<NumDTO> homePageCountForOperationByDept(FilterByDeptVO filterByDeptVO) {
        return baseMapper.homePageCountForOperationByDept(filterByDeptVO);
    }
}